--[[ 
This will make powerups spawn at emblem locations.
	*A bit of this code was taken from the StarCoins addon, which is Open Assets.
This will also provide the coding for the powerups.
Big thanks to Lach and Monster Lestyn for helping me get the robot working correctly.
]]--

local ta_boss = false

COM_AddCommand("tapickup", function(player)
	local mo = player.mo
	if not ((player and player.valid) and (mo and mo.valid))
	or mo.skin ~= "tatails"
		return
	end
	
	if P_IsObjectOnGround(mo)
	and (mo.state == S_PLAY_STND or mo.state == S_PLAY_WAIT)
		if player.tapickuptoggle == 1
			CONS_Printf(player, "Pickup animation has been turned off for you.")
			player.tapickuptoggle = 0
		else
			player.tapickuptoggle = 1
			CONS_Printf(player, "Pickup animation has been turned on for you.")
		end
	else
		CONS_Printf(player, "You can't do this right now.")
	end
end)

COM_AddCommand("tarobothardmode", function(player)
	local mo = player.mo
	if not ((player and player.valid) and (mo and mo.valid))
	or mo.skin ~= "tatails"
		return
	end
	
	if not player.tailsroboting
		if player.tarobohard == 1
			CONS_Printf(player, "Robot Hardmode has been turned off.")
			player.tarobohard = 0
		else
			player.tarobohard = 1
			CONS_Printf(player, "Robot Hardmode has been turned on.")
		end
	else
		CONS_Printf(player, "You can't do this right now.")
	end
end, COM_ADMIN)
	
//Powerup RNG Table
//Huge shoutout to Amperbee for the help on getting me to understand how the fuck this all works
local powerups = {
	MT_RAIDO,
	MT_NAPALM,
	MT_RUNSHOE,
	MT_ROBOT,
	MT_HELMET,
	MT_TASONIC,
	MT_FANG,
	MT_TELEPORT,
	MT_BIGBOMB,
	MT_TRIPLE,
	MT_GLOVE,
	MT_NIGHTVISION,
	MT_RADAR
}

local collected_emblems = {}

local function should_marathon_reset()
    return marathonmode & MA_INGAME != 0 and gamemap == spmarathon_start and consoleplayer.starpostnum <= 0
end

local house
local mappowers = {}

//If TA Exists, Replace Emblems and Spawn House
addHook("MapLoad", function()
	if should_marathon_reset() then
		if consoleplayer and consoleplayer.mo and consoleplayer.mo.skin == "tatails"
			consoleplayer.tailsrun = false
			consoleplayer.tailshelmet = false
			consoleplayer.tailsnapalm = false
			consoleplayer.tailsraido = false
			consoleplayer.tailsrobot = false
			consoleplayer.tailssonic = false
			consoleplayer.tailsfang = false
			consoleplayer.tailsteleport = false
			consoleplayer.tailsglove = false
			consoleplayer.tailsnight = false
			consoleplayer.tailstriple = false
			consoleplayer.tailslarge = false
			consoleplayer.tailsradar = false
			consoleplayer.tailsselect = 1
			collected_emblems = {} -- clear powerup cache
		end
	end
	ta_boss = false
	if not (house and house.valid)
		if (maptol & TOL_NIGHTS) then return end
		for mapt in mapthings.iterate do
			if mapt.type == 1
				local playerx, playery, playerz = mapt.x*FU, mapt.y*FU, mapt.z*FU
				local floorz = P_FloorzAtPos(playerx, playery, -3456*FU, 115*FU)
				house = P_SpawnMobj(playerx, playery, (playerz + floorz), MT_HOUSE)
			end
		end
	end
	for mapt in mapthings.iterate do
		if mapt.type == mobjinfo[MT_EMBLEM].doomednum then
			if collected_emblems[mapt.angle + 1] then
				continue
			end
			local x = mapt.x*FRACUNIT
			local y = mapt.y*FRACUNIT
			local floor = R_PointInSubsector(x, y).sector.floorheight -- Base Floor Height for Z check.
			local slope = R_PointInSubsectorOrNil(x,y).sector.f_slope    -- Check for slope

			if slope != nil    -- If ring is on a slope
				floor = P_GetZAt(slope,x,y) -- Use slope position as floor height instead
            end
			
            local z = floor + 32*FRACUNIT + mapt.z*FRACUNIT
			local randomPower = P_RandomRange(1, #powerups)
			local randomPowerValue = powerups[randomPower]
			local power = P_SpawnMobj(x, y, z, randomPowerValue)
			power.angle = mapt.angle
		end
	end
	for mo in mobjs.iterate()
		if mo.type == MT_RAIDO
		or mo.type == MT_NAPALM
		or mo.type == MT_RUNSHOE
		or mo.type == MT_ROBOT
		or mo.type == MT_HELMET
		or mo.type == MT_TASONIC
		or mo.type == MT_FANG
		or mo.type == MT_TELEPORT
		or mo.type == MT_BIGBOMB
		or mo.type == MT_TRIPLE
		or mo.type == MT_GLOVE
		or mo.type == MT_NIGHTVISION
		or mo.type == MT_RADAR
			table.insert(mappowers, mo)
		end
	end
end)

//Taken from Rouge Legacy, which is Open Assets
addHook("ThinkFrame", do
	for player in players.iterate
		if not ((player and player.valid) and (player.mo and player.mo.valid))
		or player.mo.skin ~= "tatails"
		or not player.tailsradar
		or player.inventory[player.tailsselect] ~= "RADAR"
			continue 
		end
	
		if leveltime & 127 == 0 return end
	
		local nearest, nearestemblem = nil, nil
		for _, emblem in pairs(mappowers)
			if not emblem.valid continue end
			local distance = abs(FixedHypot(emblem.x - player.mo.x, FixedHypot(emblem.y - player.mo.y, emblem.z - player.mo.z)))
			if nearest == nil or distance < nearest nearest = distance nearestemblem = emblem end
		end
		
		if not nearestemblem or nearest > 3000*FRACUNIT
			player.mo.radar = 0
			continue
		end
		
		if nearest <= 3000 * FRACUNIT
		and nearest >= 2000 * FRACUNIT
			player.mo.radar = 1
		end
		if nearest <= 2000 * FRACUNIT
		and nearest >= 1500 * FRACUNIT
			player.mo.radar = 2
		end
		if nearest <= 1500 * FRACUNIT
		and nearest >= 1000 * FRACUNIT
			player.mo.radar = 3
		end
		if nearest <= 1000 * FRACUNIT
		and nearest >= 350 * FRACUNIT
			player.mo.radar = 4
		end
		if nearest <= 350 * FRACUNIT
		and nearest >= 0 * FRACUNIT
			player.mo.radar = 5
		end
	end
end)

addHook("NetVars", function(n)
	house = n($)
	mappowers = n($)
end)

--Rouge Part 2
local function TA_RadarHUD(v, player)
	if player.mo 
	and player.mo.skin == "tatails"
	and player.tailsradar
	and player.inventory[player.tailsselect] == "RADAR"
		local x = 25
		local y = 74
		if player.mo.radar == 0
			v.draw(x, y, v.cachePatch("EMBLEM1"), V_SNAPTOLEFT)
		end
		if player.mo.radar == 1
			v.draw(x, y, v.cachePatch("EMBLEM2"), V_SNAPTOLEFT)
		end
		if player.mo.radar == 2
			v.draw(x, y, v.cachePatch("EMBLEM3"), V_SNAPTOLEFT)
		end
		if player.mo.radar == 3
			v.draw(x, y, v.cachePatch("EMBLEM4"), V_SNAPTOLEFT)
		end
		if player.mo.radar == 4
			v.draw(x, y, v.cachePatch("EMBLEM5"), V_SNAPTOLEFT)
		end
		if player.mo.radar == 5
			v.draw(x, y, v.cachePatch("EMBLEM6"), V_SNAPTOLEFT)
		end
	end
end

hud.add(TA_RadarHUD)

-- reset collected power cache
addHook("MapChange", function(m)
	if m ~= gamemap then
		collected_emblems = {}
	end
end)

-- reset collected power cache when exiting to title/desktop
addHook("GameQuit", function(quitting)
	collected_emblems = {}
end)

-- Part 2
addHook("MobjThinker", function(s)
	if not (displayplayer and displayplayer.valid) return end
	if displayplayer.mo.skin ~= "tatails" return end
	
	if s.valid
		s.flags = $|MF2_DONTDRAW
	end
end, MT_EMBLEM)

local IsValid = function(mo)
	return (mo and mo.valid)
end

//Run Power Obtained
addHook("TouchSpecial", function(emblem, s)
	if IsValid(emblem) and emblem.health
	and IsValid(s) and s.player
		if s.player.mo.skin ~= "tatails"
			return true
		end
		if not (s.player.tailsroboting
		or (s.player.mo.state == S_HELM or s.player.mo.state == S_HELMB)
		or s.player.exiting)
			if s.player.mo.state ~= S_TAILS_PICKUP
			and s.player.tapickuptoggle == 1
				s.player.mo.state = S_TAILS_PICKUP
				s.player.justpickedup = "Run Boots"
				s.player.itemmover = P_SpawnMobjFromMobj(s.player.mo, 0, 0, 0, MT_OVERLAY)
				s.player.itemmover.target = s.player.mo
				s.player.itemmover.state = S_RUNPOWER
				s.player.itemmover.spritexoffset = -18*FU
				s.player.itemmover.spriteyoffset = 50*FU
				s.player.itemmovetimer = 65
				s.player.tapickup = true
			end
		end
		collected_emblems[emblem.angle + 1] = true
		s.player.tailsrun = true
		emblem.health = 0
		emblem.fuse = 25
		emblem.flags = $ & ~(MF_NOGRAVITY)
	end
end, MT_RUNSHOE)

addHook("PlayerThink", function(player)
	if (player.mo and player.mo.valid)
	and player.mo.skin == "tatails"
		if player.itemmovetimer == nil
			player.itemmovetimer = 0
		end
		if player.itemmovetimer > 0
			player.itemmovetimer = $ - 1
		end
		if player.itemmovetimer == 64
			player.itemmover.spritexoffset = -18*FU
			player.itemmover.spriteyoffset = 50*FU
		elseif player.itemmovetimer == 58
			player.itemmover.spritexoffset = 18*FU
			player.itemmover.spriteyoffset = 54*FU
		elseif player.itemmovetimer == 50
			player.itemmover.spritexoffset = 28*FU
			player.itemmover.spriteyoffset = 52*FU
		elseif player.itemmovetimer == 18
			player.itemmover.spritexoffset = 18*FU
			player.itemmover.spriteyoffset = 54*FU
		elseif player.itemmovetimer == 10
			player.itemmover.spritexoffset = -18*FU
			player.itemmover.spriteyoffset = 50*FU
		end
		if player.itemmovetimer == 2
			P_KillMobj(player.itemmover)
		end
	end
end)

//Shoes Make Tails Faster
//Code by Lach, the G.O.A.T
local MODE_DEFAULT = 0
local MODE_TAILSRUN = 1
local MODE_2PBOT = 2
local MODE_TAILSSUPERRUN = 3

local tailsstats = {
    [MODE_DEFAULT] = {
        normalspeed = 32*FRACUNIT,
        acceleration = 50,
        accelstart = 192,
        thrustfactor = 3
    },
    [MODE_TAILSRUN] = {
        normalspeed = 39*FRACUNIT,
        acceleration = 40,
        accelstart = 96,
        thrustfactor = 5
    },
    [MODE_2PBOT] = {
        normalspeed = 36*FRACUNIT,
        acceleration = 32,
        accelstart = 76,
        thrustfactor = 6
    },
	[MODE_TAILSSUPERRUN] = {
        normalspeed = 36*FRACUNIT,
        acceleration = 40,
        accelstart = 96,
        thrustfactor = 5
    }
}

local function GetTailsMode(player)
    if (player.tailsrun
	and player.inventory[player.tailsselect] == "SHOES"
	and not player.powers[pw_super])
		return MODE_TAILSRUN
	end
	if (player.tailsrun
	and player.inventory[player.tailsselect] == "SHOES"
	and player.powers[pw_super])
		return MODE_TAILSSUPERRUN
	end
    if player.bot == BOT_2PAI
        return MODE_2PBOT
    end
	return MODE_DEFAULT
end

//Helmet Obtained
addHook("TouchSpecial", function(emblem, s)
	if IsValid(emblem) and emblem.health
	and IsValid(s) and s.player
		if s.player.mo.skin ~= "tatails"
			return true
		end
		if not (s.player.tailsroboting
		or (s.player.mo.state == S_HELM or s.player.mo.state == S_HELMB)
		or s.player.exiting)
			if s.player.mo.state ~= S_TAILS_PICKUP
			and s.player.tapickuptoggle == 1
				s.player.mo.state = S_TAILS_PICKUP
				s.player.justpickedup = "Helmet"
				s.player.itemmover = P_SpawnMobjFromMobj(s.player.mo, 0, 0, 0, MT_OVERLAY)
				s.player.itemmover.target = s.player.mo
				s.player.itemmover.state = S_HELMETPOWER
				s.player.itemmover.spritexoffset = -18*FU
				s.player.itemmover.spriteyoffset = 50*FU
				s.player.itemmovetimer = 65
				s.player.tapickup = true
			end
		end
		collected_emblems[emblem.angle + 1] = true
		s.player.tailshelmet = true
		emblem.health = 0
		emblem.fuse = 25
		emblem.flags = $ & ~(MF_NOGRAVITY)
	end
end, MT_HELMET)

local monitor = nil
local autoaim = nil

//Napalm Obtained
addHook("TouchSpecial", function(emblem, s)
	if IsValid(emblem) and emblem.health
	and IsValid(s) and s.player
		if s.player.mo.skin ~= "tatails"
			return true
		end
		if not (s.player.tailsroboting
		or (s.player.mo.state == S_HELM or s.player.mo.state == S_HELMB)
		or s.player.exiting)
			if s.player.mo.state ~= S_TAILS_PICKUP
			and s.player.tapickuptoggle == 1
				s.player.mo.state = S_TAILS_PICKUP
				s.player.justpickedup = "Napalm"
				s.player.itemmover = P_SpawnMobjFromMobj(s.player.mo, 0, 0, 0, MT_OVERLAY)
				s.player.itemmover.target = s.player.mo
				s.player.itemmover.state = S_NAPALMPOWER
				s.player.itemmover.spritexoffset = -18*FU
				s.player.itemmover.spriteyoffset = 50*FU
				s.player.itemmovetimer = 65
				s.player.tapickup = true
			end
		end
		collected_emblems[emblem.angle + 1] = true
		s.player.tailsnapalm = true
		emblem.health = 0
		emblem.fuse = 25
		emblem.flags = $ & ~(MF_NOGRAVITY)
	end
end, MT_NAPALM)

//Napalm Thinker
addHook("MobjThinker", function(mobj)
	if not (mobj.flags & MF_MISSILE)
		local maxdist = 10*mobj.scale
		if P_IsObjectOnGround(mobj)
			P_Thrust(mobj, mobj.angle, 1*FU)
		end
		if not P_IsObjectOnGround(mobj)
			P_SetObjectMomZ(mobj, -8*FU)
		end
		searchBlockmap("objects",function(refmobj,mo)
			if mo and mo.valid and mo.health
			and (mo.type == MT_SPIKE 
			or mo.type == MT_WALLSPIKE
			or mo.type == MT_SALOONDOORCENTER
			or (mo.type ~= MT_PLAYER and mo.flags & MF_SHOOTABLE !=0))
				if (mo.flags & MF_BOSS)
					return
				end
				P_KillMobj(mo, mobj, mobj.target)
			end
		end, mobj,mobj.x-maxdist,mobj.x+maxdist,mobj.y-maxdist,mobj.y+maxdist)
	end
end, MT_NAPALMPRO)

//Big Bomb Obtained
addHook("TouchSpecial", function(emblem, s)
	if IsValid(emblem) and emblem.health
	and IsValid(s) and s.player
		if s.player.mo.skin ~= "tatails"
			return true
		end
		if not (s.player.tailsroboting
		or (s.player.mo.state == S_HELM or s.player.mo.state == S_HELMB)
		or s.player.exiting)
			if s.player.mo.state ~= S_TAILS_PICKUP
			and s.player.tapickuptoggle == 1
				s.player.mo.state = S_TAILS_PICKUP
				s.player.justpickedup = "Big Bomb"
				s.player.itemmover = P_SpawnMobjFromMobj(s.player.mo, 0, 0, 0, MT_OVERLAY)
				s.player.itemmover.target = s.player.mo
				s.player.itemmover.state = S_BIGPOWER
				s.player.itemmover.spritexoffset = -18*FU
				s.player.itemmover.spriteyoffset = 50*FU
				s.player.itemmovetimer = 65
				s.player.tapickup = true
			end
		end
		collected_emblems[emblem.angle + 1] = true
		s.player.tailslarge = true
		emblem.health = 0
		emblem.fuse = 25
		emblem.flags = $ & ~(MF_NOGRAVITY)
	end
end, MT_BIGBOMB)

//Big Bomb Thinkers
addHook("ThinkFrame", function() -- Code from Dummy Ring Bomb, which is Open Assets
	for player in players.iterate do
		if not ((player and player.valid) and (player.mo and player.mo.valid)) return end
		if player.mo.skin ~= "tatails" then
			continue
		end
		if not (player.exiting) // If the player isn't exiting the level...
			if not (P_PlayerInPain(player) or (player.playerstate == PST_DEAD)) // Then, if the player isn't in pain or dead...
				if ((player.powers[pw_carry] == CR_NONE) and not (player.pflags == PF_SPINNING)) // Then if the player isn't being carried or spinning...
					-- Conditions in which you're ready to shoot
					if player.mo.state == S_PLAY_WALK or player.mo.state == S_PLAY_RUN or player.pflags & PF_JUMPED or player.mo.state == S_PLAY_STND or player.mo.state == S_PLAY_WAIT or player.mo.state == S_PLAY_FLY
						if player.cust3tapping and not player.bombcooldown // If the above function is true while the cooldown isn't active...
							if autoaim and autoaim.valid and player.mo.state != S_PLAY_FLY
								monitor = P_SpawnMissile(player.mo, autoaim, MT_LARGEPRO)
								if (player.mo.momz > 0 and not player.powers[pw_tailsfly]) // If you're moving vertically, but not flying...
									monitor.momz = (player.mo.momz)+(7*FRACUNIT) -- Launches the monitor based on your vertical momentum
								else // Otherwise...
									if (player.powers[pw_tailsfly]) // If the player is flying...
										monitor.momz = 0*FRACUNIT -- The monitor will be dropped
									else
										monitor.momz = 7*FRACUNIT -- The monitor will be launched upwards
									end
								end
								if (player.mo.eflags & MFE_VERTICALFLIP) // If the player is upside down...
									if (player.powers[pw_tailsfly])
										monitor.momz = 0*FRACUNIT
									else
										monitor.momz = -7*FRACUNIT -- Launches it in the opposite direction
									end
								end
								if not (player.powers[pw_tailsfly]) // If the player isn't flying...
									P_InstaThrust(monitor, player.mo.angle, ((player.speed)+(7*FRACUNIT))) -- Throws the monitor based on your angle and speed
								end
							end
						end
					end
				end
			end
		end
	end
end)

--Part 2
addHook("MobjThinker", function(flamen)
	-- Defines the player
	for player in players.iterate do
		if player.mo.skin ~= "tatails"
			return
		end
		local p = player.mo
		-- Gravity Flip
		if (p.eflags & MFE_VERTICALFLIP)
			flamen.eflags = $1|MFE_VERTICALFLIP -- Considers it flipped
			flamen.flags2 = $1|MF2_OBJECTFLIP -- Visually flips it upside down
		end
		-- Floor breaking
		if P_IsObjectOnGround(flamen) // If the napalm is on the ground...
			for x = flamen.x, flamen.x + flamen.radius, flamen.radius -- The following will set up variables for floor breaking
				for y = flamen.y, flamen.y + flamen.radius, flamen.radius
					local ss = R_PointInSubsector(x,y)
					for fof in ss.sector.ffloors()
						if (fof.flags & FF_BUSTUP) and (fof.flags & FF_EXISTS) // If a breakable floor exists where the napalm lands...
							EV_CrumbleChain(ss.sector, fof) -- Breaks that floor
						end
					end
				end
			end
		end
	end
end, MT_LARGEPRO)

--Part 3
addHook("MobjThinker", function(mobj)
	if not (mobj.flags & MF_MISSILE)
		mobj.timer = $ - 1
		if mobj.timer == 1
			local maxdist = 194*mobj.scale
			mobj.state = S_LARGE_EXPLODE
			mobj.flags = $|MF_NOGRAVITY
			mobj.timer = 0
			searchBlockmap("objects",function(refmobj,mo)
				if mo and mo.valid and mo.health
				and (mo.type == MT_SPIKE 
				or mo.type == MT_WALLSPIKE
				or mo.type == MT_SALOONDOORCENTER
				or (mo.type ~= MT_PLAYER and mo.flags & MF_SHOOTABLE !=0))
					if (mo.flags & MF_BOSS)
						return
					end
					P_KillMobj(mo, mobj, mobj.target)
				end
			end, mobj,mobj.x-maxdist,mobj.x+maxdist,mobj.y-maxdist,mobj.y+maxdist)
		end
	end
end, MT_LARGEPRO)

--Part 4
addHook("MobjSpawn", function(bbomb)
	local scale = FU*4
	bbomb.spritexscale,bbomb.spriteyscale = scale,scale
	if bbomb.timer == nil
		bbomb.timer = 3*TICRATE
	end
end, MT_LARGEPRO)

//Make The Big Bomb Do Double Damage
addHook("MobjDamage", function(mobj, inf, src, dmg, dmgtype)
	if not inf
		return
	end
	
	if inf.type == MT_LARGEPRO and mobj.health > 1 and dmg <= 1 and inf.timer == 1
		P_DamageMobj(mobj, inf, src, dmg*2, dmgtype)
		return true
	end
end)

//What Is A Wall????
local wallbreak = function(mobj, sectorthing)
	for fof in sectorthing.ffloors()
		if fof.valid and (fof.flags & FF_BUSTUP) and (fof.flags & FF_EXISTS)
			local foffloor = fof.topheight
			local fofceiling = fof.bottomheight
			if fof.b_slope and fof.b_slope.valid
				fofceiling = P_GetZAt(fof.b_slope, mobj.x, mobj.y)
			end
			if fof.t_slope and fof.t_slope.valid
				foffloor = P_GetZAt(fof.t_slope, mobj.x, mobj.y)
			end
			if foffloor >= mobj.z and fofceiling <= mobj.z+mobj.height
				EV_CrumbleChain(nil, fof)
				if fof.master.flags & ML_EFFECT5
					P_LinedefExecute(P_AproxDistance(fof.master.dx, fof.master.dy)>>FRACBITS, mobj, sectorthing)
				end
				return true
			end
		end
	end
end

//Break The Walls, Big Bomb Edition
addHook("MobjLineCollide", function(mobj, line)
	local mlemn -- Because :3
	local mlemn2 -- Because I'm so :3
	if not (line and line.valid and mobj and mobj.valid)
		return
	end
	
	if line.frontsector
	and line.frontsector.valid
		mlemn = wallbreak(mobj,line.frontsector)
	end
	
	if line.backsector
	and line.backsector.valid
		mlemn2 = wallbreak(mobj, line.backsector)
	end
	
	if mlemn
	or mlemn2
		P_ExplodeMissile(mobj)
	end
end, MT_LARGEPRO)

//Same thing but for Napalm
addHook("MobjLineCollide", function(mobj, line)
	local mlemn -- Because :3
	local mlemn2 -- Because I'm so :3
	if not (line and line.valid and mobj and mobj.valid)
		return
	end
	
	if line.frontsector
	and line.frontsector.valid
		mlemn = wallbreak(mobj,line.frontsector)
	end
	
	if line.backsector
	and line.backsector.valid
		mlemn2 = wallbreak(mobj, line.backsector)
	end
	
	if mlemn
	or mlemn2
		P_ExplodeMissile(mobj)
	end
end, MT_NAPALMPRO)

//Robot Obtained
addHook("TouchSpecial", function(emblem, s)
	if IsValid(emblem) and emblem.health
	and IsValid(s) and s.player
		if s.player.mo.skin ~= "tatails"
			return true
		end
		if not (s.player.tailsroboting
		or (s.player.mo.state == S_HELM or s.player.mo.state == S_HELMB)
		or s.player.exiting)
			if s.player.mo.state ~= S_TAILS_PICKUP
			and s.player.tapickuptoggle == 1
				s.player.mo.state = S_TAILS_PICKUP
				s.player.justpickedup = "Remote Robot"
				s.player.itemmover = P_SpawnMobjFromMobj(s.player.mo, 0, 0, 0, MT_OVERLAY)
				s.player.itemmover.target = s.player.mo
				s.player.itemmover.state = S_ROBOTPOWER
				s.player.itemmover.spritexoffset = -18*FU
				s.player.itemmover.spriteyoffset = 50*FU
				s.player.itemmovetimer = 65
				s.player.tapickup = true
			end
		end
		collected_emblems[emblem.angle + 1] = true
		s.player.tailsrobot = true
		emblem.health = 0
		emblem.fuse = 25
		emblem.flags = $ & ~(MF_NOGRAVITY)
	end
end, MT_ROBOT)

--If the robot crosses the finish, give it a signpost!
function A_SignPlayer(mobj, var1, var2)
    super(mobj, var1, var2)
    if var1 == -1 and mobj.tracer and mobj.tracer.valid
    and mobj.tracer.tracer and mobj.tracer.tracer.valid 
    and mobj.target and mobj.target.valid and mobj.target.player
    and mobj.target.skin == "tatails" and mobj.target.player.tailsroboting == true
        mobj.tracer.tracer.sprite = SPR_RBSI
        mobj.tracer.tracer.tics = -1
    end
end

--Make the Robot smaller
addHook("MobjSpawn", function(robot)
	local scale = FU*3/4
	robot.spritexscale,robot.spriteyscale = scale,scale
end, MT_ROBOTPRO)

--Because the Robot and Sub have weird behaviors on death
addHook("PlayerSpawn", function(player)
	if not ((player and player.valid) and (player.mo and player.mo.valid))
	or player.mo.skin ~= "tatails"
		return
	end
	player.tailsroboting = false
	player.tailssubbing = false
	player.hp = 10
end)

--Fix visual oddities with the sub
addHook("PostThinkFrame", do
	for player in players.iterate
		if not (player.mo and player.mo.valid)
		or player.mo.skin ~= "tatails"
			continue
		end
		
		if not (P_IsObjectOnGround(player.mo)
		or player.playerstate == PST_DEAD)
			if player.mo.state == S_PLAY_WALK
			or player.mo.state == S_PLAY_RUN
			or player.mo.state == S_PLAY_DASH
			or player.mo.state == S_PLAY_SKID
				player.mo.state = S_TAILS_CORK
			end
		end
	
		if player.tailssubbing
			if player.mo.state ~= S_TAILS_SUBBING
				if player.mo.state == S_PLAY_DEAD
					continue
				end
				player.mo.state = S_TAILS_SUBBING
			end
		end
		
		if player.tapickup
			if player.mo.state ~= S_TAILS_PICKUP
				if (player.mo.state == S_TAILS_PICKUP2 or player.mo.state == S_TAILS_AWAY)
					continue
				end
				player.mo.state = S_TAILS_PICKUP
			end
		end
		
		if player.mo.tasleep
			player.mo.spritexscale = 4*FU/3
			player.mo.spriteyscale = 4*FU/3
		end
	end
end)

-- I couldn't make the robot explode so instead it will shoot corks because I'm not smart T-T
-- Code from OpenCharacterAssets
addHook("PlayerThink", function(player)
	local skin = "tatails" // your character here
	local thebutton1 = BT_ATTACK // the button needed to fire the projectile
	local sound1 = sfx_cdfm70 // the shooting sound
	local projectile1 = MT_CORK // the projectile itself
	local autoaim1 = true // if this is true, the projectile is automatically aimed
	local hasdelay1 = true // if this is true, you will have a delay while firing
	local firedelay1 = 4 // the delay of firing if hasdelay is true
	local theproj1 = MT_NULL
	
	local sound2 = sfx_sublm // the shooting sound
	local projectile2 = MT_PELLETPRO // the projectile itself
	local autoaim2 = false// if this is true, the projectile is automatically aimed
	local hasdelay2 = true // if this is true, you will have a delay while firing
	
	if player.tailsroboting
		if player.mo.shootaim == nil
			player.mo.shootaim = 0
		end
		if player.mo.projangle == nil
			player.mo.projangle = 0
		end
		if player.mo.buttonholding == nil
			player.mo.buttonholding = false
		end
		if not (player.cmd.buttons & thebutton1) 
			player.mo.buttonholding = false
		end
		if player.mo and player.mo.skin == skin
		and autoaim1 == true
		and player.weapondelay == 0
			player.mo.shootaim = P_LookForEnemies(player, false, true)
			if player.mo.shootaim and player.mo.shootaim.valid and player.mo.shootaim.health
				player.mo.projangle = R_PointToAngle2(player.mo.x, player.mo.y, player.mo.shootaim.x, player.mo.shootaim.y)
				P_SpawnLockOn(player, player.mo.shootaim, S_LOCKON1)
			end
		end
		if player.mo and player.mo.skin == skin
		and (player.cmd.buttons & thebutton1)
		and hasdelay1 == true
		and not player.weapondelay
		and player.tailsroboting
			if player.mo.shootaim and player.mo.shootaim.valid and autoaim1 == true
				theproj1 = P_SpawnMissile(player.mo, player.mo.shootaim, projectile1)
			else
				theproj1 = P_SpawnPlayerMissile(player.mo,projectile1)
			end
			S_StartSound(player.mo, sound1)
			player.weapondelay = TICRATE*firedelay1
			if hasrecoil == true
				P_InstaThrust(player.mo, player.mo.angle, -FRACUNIT*recoil)
			end
		end
		if player.mo and player.mo.skin == skin
		and (player.cmd.buttons & thebutton1)
		and hasdelay1 == false
		and not player.mo.buttonholding
			player.mo.buttonholding = true
			if player.mo.shootaim and player.mo.shootaim.valid and autoaim1 == true
				P_SpawnMissile(player.mo, player.mo.shootaim, projectile1)
			else
				P_SPMAngle(player.mo,projectile1,player.mo.angle,0)
			end
			S_StartSound(player.mo, sound1)
			if hasrecoil == true
				P_InstaThrust(player.mo, player.mo.angle, -FRACUNIT*recoil)
			end
		end
	end
	
	if player.tailssubbing
		if player.mo.shootaim == nil
			player.mo.shootaim = 0
		end
		if player.mo.projangle == nil
			player.mo.projangle = 0
		end
		if player.mo.buttonholding == nil
			player.mo.buttonholding = false
		end
		if not (player.cmd.buttons & thebutton1) 
			player.mo.buttonholding = false
		end
		if player.mo and player.mo.skin == skin
		and (player.cmd.buttons & thebutton1)
		and hasdelay2 == true
		and not player.weapondelay
			local theproj2 = P_SpawnPlayerMissile(player.mo, projectile2)
			S_StartSound(player.mo, sound2)
			player.weapondelay = TICRATE/4
		end
	end
end)

--Enter the Sub
addHook("TouchSpecial", function(tsub, p)
	if (p and p.valid)
	and p.skin == "tatails"
	and (tsub and tsub.valid)
	and not p.player.tailsroboting
	and tsub.state == S_TAILS_ROBOTRANS2
	and not (p.player.cmd.buttons & BT_CUSTOM1)
		p.player.tawarpsub = true
	end
	return true
end, MT_ROBOSUB)

--Setup the sub's hp
addHook("PlayerSpawn", function(player)
    if player.mo and player.mo.skin == "tatails"
		player.maxsubhealth = 3
		player.subhpmax = 3
		player.maxrobothp = 3
		player.robothpmax = 3
		if player.subhp == nil
			player.subhp = player.subhpmax
		end
		if player.robohealth == nil
			player.robohealth = player.robothpmax
		end
	end
end)

addHook("PlayerThink", function(player)
	if not ((player and player.valid) and (player.mo and player.mo.valid)) return end
	if player.mo.skin == "tatails" 
		if player.robosub and player.robosub.valid
		and player.subhp > player.subhpmax
			player.subhp = 3
		end
		if player.tailsroboting
		and player.tarobohard == 0
		and player.robohealth > player.robothpmax
			player.robohealth = 3
		end
	end
end)


hud.add(function(v,player)
	if player.mo and player.mo.skin == "tatails"
		if player.tailssubbing
			local xpos = hudinfo[HUD_RINGS].x
			local ypos = hudinfo[HUD_RINGS].y
			if player.subhp > player.subhpmax/2
				v.drawString(xpos, (ypos + 30), ("SUB HEALTH: " + (player.subhp) + " / " + (player.subhpmax)), V_PERPLAYER|V_GREENMAP|V_SNAPTOLEFT)
			else
				v.drawString(xpos, (ypos + 30), ("SUB HEALTH: " + (player.subhp) + " / " + (player.subhpmax)), V_PERPLAYER|V_REDMAP|V_SNAPTOLEFT)
			end
		end
		if player.tailsroboting
		and player.tarobohard == 0
		and ta_boss
			local xpos = hudinfo[HUD_RINGS].x
			local ypos = hudinfo[HUD_RINGS].y
			if player.robohealth > player.robothpmax/2
				v.drawString(xpos, (ypos + 30), ("ROBOT HEALTH: " + (player.robohealth) + " / " + (player.robothpmax)), V_PERPLAYER|V_GREENMAP|V_SNAPTOLEFT)
			else
				v.drawString(xpos, (ypos + 30), ("ROBOT HEALTH: " + (player.robohealth) + " / " + (player.robothpmax)), V_PERPLAYER|V_REDMAP|V_SNAPTOLEFT)
			end
		end
	end
end)

addHook("MobjDamage", function(target, inf, src, dmg, dmgType)
	if target.skin == "tatails" and not target.player.powers[pw_super]
		local mode = GetTailsMode(target)
		local stats = tailsstats[mode]
		if target.player.tailssubbing
		and not target.player.tailsroboting
			target.player.powers[pw_flashing] = 50
			target.player.subhp = $ - 1
			if target.player.subhp > 0
				S_StartSound(target, sfx_dmpain)
			end
			P_DoPlayerPain(target.player, src, inf)
			P_PlayerFlagBurst(target.player,false)
			if target.player.subhp == 0
				P_PlayerRingBurst(target.player, target.player.rings)
				if target.player.rings != 0
					S_StartSound(target, sfx_altow1)
				end
				S_StartSound(target, sfx_bkpoof)
				target.player.tailssubbing = false
				target.player.powers[pw_underwater] = 30*TICRATE
				target.player.mo.spritexscale = FU
				target.player.mo.spriteyscale = FU
				target.player.mo.state = S_TAILS_CORK
				target.player.rings = 0
				target.player.robotcooldown = 30*TICRATE
				target.player.robosubexplode = P_SpawnMobjFromMobj(target.player.mo, 0, 0, 0, MT_SONIC3KBOSSEXPLODE)
				target.player.robosubexplode.state = S_FBOMB_EXPL1
				target.player.subhp = 3
			end
		end
		if target.player.tailsroboting
		and target.player.robohealth
		and target.player.tarobohard == 0
			target.player.powers[pw_flashing] = 50
			target.player.robohealth = $ - 1
			if target.player.robohealth > 0
				S_StartSound(target, sfx_dmpain)
			end
			P_DoPlayerPain(target.player, src, inf)
			P_PlayerFlagBurst(target.player,false)
			if target.player.robohealth == 0
				S_StartSound(target, sfx_pop)
				P_SetOrigin(target, target.player.robot.x, target.player.robot.y, target.player.robot.z)
				P_RemoveMobj(target.player.realrobot)
				P_RemoveMobj(target.player.robot)
				target.player.normalspeed = stats.normalspeed
				target.player.height = 48*FU
				target.player.tailsroboting = false
				target.player.robotcooldown = 30*TICRATE
				target.player.robohealth = 3
			end
		return true
		end
	end
end, MT_PLAYER)

addHook("TouchSpecial", function(bubble, tatails)
	if not (tatails and tatails.valid and tatails.player and bubble and bubble.valid) return end
	if tatails.skin == "tatails"
	and tatails.player.tailssubbing
		return true
	end
end, MT_EXTRALARGEBUBBLE)

addHook("ShouldDamage", function(tatails, inflictor, source, damage, damagetype)
	if damagetype == DMG_CRUSHED
	or damagetype == DMG_DEATHPIT
		if not (tatails or tatails.valid or tatails.player or tatails.skin ~= "tatails") return end
		if tatails.player.tailsroboting
		and tatails.player.tarobohard == 0
			P_SetOrigin(tatails.player.mo, tatails.player.robot.x, tatails.player.robot.y, tatails.player.robot.z)
			P_RemoveMobj(tatails.player.robot)
			P_RemoveMobj(tatails.player.realrobot)
			local mode = GetTailsMode(tatails.player)
			local stats = tailsstats[mode]
			tatails.player.normalspeed = stats.normalspeed
			tatails.player.height = 48*FRACUNIT
			tatails.player.tailsroboting = false
			tatails.player.robotcooldown = 30*TICRATE
			return false
		end
	end
end, MT_PLAYER)

addHook("BossThinker", function(boss)
    if gamemap ~= 23 then
        ta_boss = true
    end
end)

addHook("PreThinkFrame", do
	for player in players.iterate
		if not ((player and player.valid) and (player.mo and player.mo.valid)) return end
		if player.mo.skin == "tatails"
		and player.tailsroboting
			if player.tarobohard == 1
				continue
			end
			if (player.pflags & PF_FINISHED)
			or player.exiting
			and not ta_boss
				player.exiting = 0
				player.pflags = $ &~(PF_FINISHED|PF_FULLSTASIS)
			end
		end
	end
end)

addHook("TouchSpecial", function(post, robo)
	if not ((post and post.valid) and (robo and robo.valid)) return end
	if robo.skin == "tatails"
	and robo.player.tailsroboting
	and robo.player.tarobohard == 0
		return true
	end
	return false
end, MT_STARPOST)

//Raido Obtained
addHook("TouchSpecial", function(emblem, s)
	if IsValid(emblem) and emblem.health
	and IsValid(s) and s.player
		if s.player.mo.skin ~= "tatails"
			return true
		end
		if not (s.player.tailsroboting
		or (s.player.mo.state == S_HELM or s.player.mo.state == S_HELMB)
		or s.player.exiting)
			if s.player.mo.state ~= S_TAILS_PICKUP
			and s.player.tapickuptoggle == 1
				s.player.mo.state = S_TAILS_PICKUP
				s.player.justpickedup = "Raido"
				s.player.itemmover = P_SpawnMobjFromMobj(s.player.mo, 0, 0, 0, MT_OVERLAY)
				s.player.itemmover.target = s.player.mo
				s.player.itemmover.state = S_RAIDOPOWER
				s.player.itemmover.spritexoffset = -18*FU
				s.player.itemmover.spriteyoffset = 50*FU
				s.player.itemmovetimer = 65
				s.player.tapickup = true
			end
		end
		collected_emblems[emblem.angle + 1] = true
		s.player.tailsraido = true
		emblem.health = 0
		emblem.fuse = 25
		emblem.flags = $ & ~(MF_NOGRAVITY)
	end
end, MT_RAIDO)

//Raido Music Table
local raidomusic = {
	"TABF",
	"TABB",
	"TACF",
	"TACI",
	"TACR",
	"TALC",
	"TALR",
	"TAMP",
	"TAPM",
	"TAPF",
	"RATH",
	"TAVT"
}

local raidotracks = {
	"Battle Fortress",
	"Boss Battle!",
	"Canon Forest",
	"Coco Island",
	"Credits",
	"Lake Crystal",
	"Lake Rocky",
	"Map",
	"Poly Mountain",
	"Poloy Forest",
	"Tails' House",
	"Volcanic Tunnel"
}

//Raido HUD
hud.add(function(v, player)
	if not ((player and player.valid) and (player.mo and player.mo.valid)) return end
	if player.mo.skin ~= "tatails"
	or player.tailssubbing
		return
	end
	local fpp = V_PERPLAYER
	if player.tailsraido
	and player.inventory[player.tailsselect] == "RAIDO"
		v.drawString(15, 95, "Song List:", fpp, "thin-center")
		local prev_track = player.raidosong - 1
		local next_track = player.raidosong + 1
		if prev_track > 0 then
			v.drawString(15, 130, raidotracks[prev_track], fpp, "small-center")
		end
		v.drawString(15, 120, raidotracks[player.raidosong], fpp|V_YELLOWMAP, "small-center")
		if next_track <= #raidotracks then
			v.drawString(15, 110, raidotracks[next_track], fpp, "small-center")
		end
	end
end)

//Sonic Obtained
addHook("TouchSpecial", function(emblem, s)
	if IsValid(emblem) and emblem.health
	and IsValid(s) and s.player
		if s.player.mo.skin ~= "tatails"
			return true
		end
		if not (s.player.tailsroboting
		or (s.player.mo.state == S_HELM or s.player.mo.state == S_HELMB)
		or s.player.exiting)
			if s.player.mo.state ~= S_TAILS_PICKUP
			and s.player.tapickuptoggle == 1
				s.player.mo.state = S_TAILS_PICKUP
				s.player.justpickedup = "Sonic"
				s.player.itemmover = P_SpawnMobjFromMobj(s.player.mo, 0, 0, 0, MT_OVERLAY)
				s.player.itemmover.target = s.player.mo
				s.player.itemmover.state = S_SONICPOWER
				s.player.itemmover.spritexoffset = -18*FU
				s.player.itemmover.spriteyoffset = 50*FU
				s.player.itemmovetimer = 65
				s.player.tapickup = true
			end
		end
		collected_emblems[emblem.angle + 1] = true
		s.player.tailssonic = true
		emblem.health = 0
		emblem.fuse = 25
		emblem.flags = $ & ~(MF_NOGRAVITY)
	end
end, MT_TASONIC)

//Fang Obtained
addHook("TouchSpecial", function(emblem, s)
	if IsValid(emblem) and emblem.health
	and IsValid(s) and s.player
		if s.player.mo.skin ~= "tatails"
			return true
		end
		if not (s.player.tailsroboting
		or (s.player.mo.state == S_HELM or s.player.mo.state == S_HELMB)
		or s.player.exiting)
			if s.player.mo.state ~= S_TAILS_PICKUP
			and s.player.tapickuptoggle == 1
				s.player.mo.state = S_TAILS_PICKUP
				s.player.justpickedup = "Fang"
				s.player.itemmover = P_SpawnMobjFromMobj(s.player.mo, 0, 0, 0, MT_OVERLAY)
				s.player.itemmover.target = s.player.mo
				s.player.itemmover.state = S_FANGPOWER
				s.player.itemmover.spritexoffset = -18*FU
				s.player.itemmover.spriteyoffset = 50*FU
				s.player.itemmovetimer = 65
				s.player.tapickup = true
			end
		end
		collected_emblems[emblem.angle + 1] = true
		s.player.tailsfang = true
		emblem.health = 0
		emblem.fuse = 25
		emblem.flags = $ & ~(MF_NOGRAVITY)
	end
end, MT_FANG)

//Glove Obtained
addHook("TouchSpecial", function(emblem, s)
	if IsValid(emblem) and emblem.health
	and IsValid(s) and s.player
		if s.player.mo.skin ~= "tatails"
			return true
		end
		if not (s.player.tailsroboting
		or (s.player.mo.state == S_HELM or s.player.mo.state == S_HELMB)
		or s.player.exiting)
			if s.player.mo.state ~= S_TAILS_PICKUP
			and s.player.tapickuptoggle == 1
				s.player.mo.state = S_TAILS_PICKUP
				s.player.justpickedup = "Glove"
				s.player.itemmover = P_SpawnMobjFromMobj(s.player.mo, 0, 0, 0, MT_OVERLAY)
				s.player.itemmover.target = s.player.mo
				s.player.itemmover.state = S_GLOVEPOWER
				s.player.itemmover.spritexoffset = -18*FU
				s.player.itemmover.spriteyoffset = 50*FU
				s.player.itemmovetimer = 65
				s.player.tapickup = true
			end
		end
		collected_emblems[emblem.angle + 1] = true
		s.player.tailsglove = true
		emblem.health = 0
		emblem.fuse = 25
		emblem.flags = $ & ~(MF_NOGRAVITY)
	end
end, MT_GLOVE)

//Night Vision Obtained
addHook("TouchSpecial", function(emblem, s)
	if IsValid(emblem) and emblem.health
	and IsValid(s) and s.player
		if s.player.mo.skin ~= "tatails"
			return true
		end
		if not (s.player.tailsroboting
		or (s.player.mo.state == S_HELM or s.player.mo.state == S_HELMB)
		or s.player.exiting)
			if s.player.mo.state ~= S_TAILS_PICKUP
			and s.player.tapickuptoggle == 1
				s.player.mo.state = S_TAILS_PICKUP
				s.player.justpickedup = "Night Vision"
				s.player.itemmover = P_SpawnMobjFromMobj(s.player.mo, 0, 0, 0, MT_OVERLAY)
				s.player.itemmover.target = s.player.mo
				s.player.itemmover.state = S_NIGHTVISIONPOWER
				s.player.itemmover.spritexoffset = -18*FU
				s.player.itemmover.spriteyoffset = 50*FU
				s.player.itemmovetimer = 65
				s.player.tapickup = true
			end
		end
		collected_emblems[emblem.angle + 1] = true
		s.player.tailsnight = true
		emblem.health = 0
		emblem.fuse = 25
		emblem.flags = $ & ~(MF_NOGRAVITY)
	end
end, MT_NIGHTVISION)

//Radar Obtained
addHook("TouchSpecial", function(emblem, s)
	if IsValid(emblem) and emblem.health
	and IsValid(s) and s.player
		if s.player.mo.skin ~= "tatails"
			return true
		end
		if not (s.player.tailsroboting
		or (s.player.mo.state == S_HELM or s.player.mo.state == S_HELMB)
		or s.player.exiting)
			if s.player.mo.state ~= S_TAILS_PICKUP
			and s.player.tapickuptoggle == 1
				s.player.mo.state = S_TAILS_PICKUP
				s.player.justpickedup = "Radar"
				s.player.itemmover = P_SpawnMobjFromMobj(s.player.mo, 0, 0, 0, MT_OVERLAY)
				s.player.itemmover.target = s.player.mo
				s.player.itemmover.state = S_RADARPOWER
				s.player.itemmover.spritexoffset = -18*FU
				s.player.itemmover.spriteyoffset = 50*FU
				s.player.itemmovetimer = 65
				s.player.tapickup = true
			end
		end
		collected_emblems[emblem.angle + 1] = true
		s.player.tailsradar = true
		emblem.health = 0
		emblem.fuse = 25
		emblem.flags = $ & ~(MF_NOGRAVITY)
	end
end, MT_RADAR)

//Enemies Drop Rings Now! 
--Code from "Enemies Drop Rings" by AlanGab2009 which is Open Assets
if not EDR_BanList
	rawset(_G, "EDR_BanList", {})
end

local enemybanlist = {
	MT_GOOMBA,
	MT_BLUEGOOMBA
}

local tarings = {
	MT_NULL,
	MT_NULL,
	MT_NULL,
	MT_NULL,
	MT_NULL,
	MT_TARING
}
local taringsfang = {
	MT_NULL,
	MT_NULL,
	MT_TARING
}

for _,enemy in ipairs(enemybanlist) do
	table.insert(EDR_BanList, enemy)
end

local function SearchInTable(t, searchfor)
	for _,item in ipairs(t) do
		if item == searchfor
			return true
		else
			continue
		end
	end
	return false
end

local function EDR_DropRing(mobj)
	if ultimatemode
		return
	end
	local randomRing = P_RandomRange(1,#tarings)
	local randomRingValue = tarings[randomRing]
	local taring = P_SpawnMobj(mobj.x, mobj.y, mobj.z, randomRingValue)
	taring.dropbyenemy = true
	taring.flags = $|MF_NOCLIPTHING
	taring.target = mobj
	taring.shadowscale = taring.scale
	taring.nocliptimer = 35
	taring.fuse = 280
	P_SetObjectMomZ(taring, 12*FRACUNIT)
end

local function EDR_DropRingFang(mobj)
	if ultimatemode
		return
	end
	local randomRing = P_RandomRange(1,#taringsfang)
	local randomRingValue = taringsfang[randomRing]
	local taring = P_SpawnMobj(mobj.x, mobj.y, mobj.z, randomRingValue)
	taring.dropbyenemy = true
	taring.flags = $|MF_NOCLIPTHING
	taring.target = mobj
	taring.nocliptimer = 35
	taring.fuse = 280
	P_SetObjectMomZ(taring, 12*FRACUNIT)
end

addHook("MobjThinker", function(ring)
	if not (ring and ring.valid)
	or not ring.dropbyenemy return end
	if ring.nocliptimer > 0
		ring.nocliptimer = $-1
	end
	if ring.nocliptimer == 0 and ring.flags & MF_NOCLIPTHING
		ring.flags = $ & ~MF_NOCLIPTHING
	end
	if ring.momz == 0 and not P_IsObjectOnGround(ring) and not ring.zmomchanged
		ring.momz = -1*FRACUNIT
		ring.zmomchanged = true
	end
end, MT_TARING)

addHook("MobjDeath", function(enemy,inflictor,source)
	if (source and source.valid
	and inflictor and inflictor.valid
	and source.skin == "tatails")
	and (inflictor.type == MT_FBOMB
	or inflictor.type == MT_LARGEPRO
	or inflictor.type == MT_NAPALMPRO
	or inflictor.skin == "tatails")
		if enemy.flags & MF_ENEMY
		and not SearchInTable(EDR_BanList, enemy.type)
		and enemy.type != MT_BIGMINE
		and enemy.type != MT_DETON
			if not (source.player.inventory[1] == "FANG"
			or source.player.inventory[2] == "FANG"
			or source.player.inventory[3] == "FANG"
			or source.player.inventory[4] == "FANG")
				EDR_DropRing(enemy)
			else
				EDR_DropRingFang(enemy)
			end
		end
		return false
	end
end)

addHook("MobjThinker", function(mine)
	if mine.state == 1017
	and not SearchInTable(EDR_BanList, mine.type)
		EDR_DropRing(mine)
	end
	return false
end, MT_BIGMINE)

addHook("MobjThinker", function(deton)
	if deton.state == 2598
	and not SearchInTable(EDR_BanList, deton.type)
	and not deton.alrexploded
		EDR_DropRing(deton)
		deton.alrexploded = true
	end
	return false
end, MT_DETON)

//Teleport Obtained
addHook("TouchSpecial", function(emblem, s)
	if IsValid(emblem) and emblem.health
	and IsValid(s) and s.player
		if s.player.mo.skin ~= "tatails"
			return true
		end
		if not (s.player.tailsroboting
		or (s.player.mo.state == S_HELM or s.player.mo.state == S_HELMB)
		or s.player.exiting)
			if s.player.mo.state ~= S_TAILS_PICKUP
			and s.player.tapickuptoggle == 1
				s.player.mo.state = S_TAILS_PICKUP
				s.player.justpickedup = "Teleport"
				s.player.itemmover = P_SpawnMobjFromMobj(s.player.mo, 0, 0, 0, MT_OVERLAY)
				s.player.itemmover.target = s.player.mo
				s.player.itemmover.state = S_TELEPOWER
				s.player.itemmover.spritexoffset = -18*FU
				s.player.itemmover.spriteyoffset = 50*FU
				s.player.itemmovetimer = 65
				s.player.tapickup = true
			end
		end
		collected_emblems[emblem.angle + 1] = true
		s.player.tailsteleport = true
		emblem.health = 0
		emblem.fuse = 25
		emblem.flags = $ & ~(MF_NOGRAVITY)
	end
end, MT_TELEPORT)

//Triple Bomb Obtained
addHook("TouchSpecial", function(emblem, s)
	if IsValid(emblem) and emblem.health
	and IsValid(s) and s.player
		if s.player.mo.skin ~= "tatails"
			return true
		end
		if not (s.player.tailsroboting
		or (s.player.mo.state == S_HELM or s.player.mo.state == S_HELMB)
		or s.player.exiting)
			if s.player.mo.state ~= S_TAILS_PICKUP
			and s.player.tapickuptoggle == 1
				s.player.mo.state = S_TAILS_PICKUP
				s.player.justpickedup = "Triple Bomb"
				s.player.itemmover = P_SpawnMobjFromMobj(s.player.mo, 0, 0, 0, MT_OVERLAY)
				s.player.itemmover.target = s.player.mo
				s.player.itemmover.state = S_TRIPLEPOWER
				s.player.itemmover.spritexoffset = -18*FU
				s.player.itemmover.spriteyoffset = 50*FU
				s.player.itemmovetimer = 65
				s.player.tapickup = true
			end
		end
		collected_emblems[emblem.angle + 1] = true
		s.player.tailstriple = true
		emblem.health = 0
		emblem.fuse = 25
		emblem.flags = $ & ~(MF_NOGRAVITY)
	end
end, MT_TRIPLE)

//Main Powerup Thinker
addHook("PlayerThink", function(player)
	if not ((player and player.valid) and (player.mo and player.mo.valid)) return end
	if player.mo.skin ~= "tatails"
	--Why its not already doing this shit on its own when I turn "tailssubbing" or "tailsroboting" to false i have no fucking idea!!!
		player.tailsroboting = false
		player.tailssubbing = false
		player.mo.spritexscale = FU
		player.mo.spriteyscale = FU
		if player.mo.state == S_TAILS_SUBBING
			player.mo.state = S_PLAY_STND
			player.powers[pw_underwater] = 30*TICRATE
		end
		if (player.realrobot and player.realrobot.valid)
			P_RemoveMobj(player.realrobot)
			P_RemoveMobj(player.robot)
		end
		if (player.nightvision and player.nightvision.valid)
			P_KillMobj(player.nightvision)
		end
		return
	end
	
	if not (player.cmd.buttons & BT_ATTACK)
		player.fireready = true
		player.firing = false
	elseif player.fireready
		player.firing = true
		player.fireready = false
	else
		player.firing = false
	end
	
-------------------------------Run Boots Controls--------------------------------------
	local mode = GetTailsMode(player)
	local stats = tailsstats[mode]
    if mode ~= player.tailsmode
		if player.exiting
		or player.powers[pw_carry] == CR_NIGHTSMODE
			return
		end
		if not player.xmomtoggledoff
			player.tailsmode = mode
			player.fakenormalspeed = stats.normalspeed
			player.acceleration = stats.acceleration
			player.accelstart = stats.accelstart
			player.thrustfactor = stats.thrustfactor
		end
		player.tailsmode = mode
		player.normalspeed = stats.normalspeed
		player.acceleration = stats.acceleration
		player.accelstart = stats.accelstart
		player.thrustfactor = stats.thrustfactor
    end
	
--------------------------------Robot Stuffs------------------------------------------
	if player.robotcooldown == nil return end
	if player.robotcooldown ~= 0
		player.robotcooldown = $ - 1
	end
	local mo = player.mo
	local p = player
	if player.firing
	and p.tailsrobot
	and p.inventory[p.tailsselect] == "ROBOT"
	and not p.tailsroboting
	and not p.exiting
	and not P_PlayerInPain(p)
	and not G_IsSpecialStage()
	and not p.tailssubbing
	and not p.weapondelay
	and p.robotcooldown == 0
		if mo.skin ~= "tatails"
			return
		end
		p.robot = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_ROBOTPRO) -- Fake Tails Mobj
		-- Fake Tails uses the player's skincolor
		p.robot.color = p.skincolor
		p.robot.shadowscale = 9*FRACUNIT/10
		-- Make the robot spawn in front of us
		P_TryMove(mo, 
		mo.x + P_ReturnThrustX(nil, mo.angle, 50*FRACUNIT),
		mo.y + P_ReturnThrustY(nil, mo.angle, 50*FRACUNIT), true)
		p.realrobot = P_SpawnMobj(mo.x, mo.y, mo.z, MT_OVERLAY) -- Real Robot Mobj
		-- The robot will follow the invisible player
		p.realrobot.target = mo
		p.realrobot.state = S_TAILS_ROBOT
		-- Robot uses the player's skin color
		p.realrobot.color = p.skincolor
		p.realrobot.shadowscale = 9*FRACUNIT/10
		p.tailsroboting = true
		p.weapondelay = 10
	end
	
	--Warp the player to the sub
	if player.tawarpsub
		player.tailssubbing = true
		P_SetOrigin(player.mo, player.robosub.x, player.robosub.y, player.robosub.z)
		P_RemoveMobj(player.robosub)
		player.tawarpsub = false
	end
	
	if p.tailsroboting
		------------------------Lets control the robot-------------------------
		if player.tarobohard == 0
			if ta_boss == false
				player.powers[pw_flashing] = 1
			end
		end
		p.normalspeed = 14*FRACUNIT
		p.height = 32*FRACUNIT
		p.mo.flags2 = $|MF2_DONTDRAW
		if p.realrobot.valid
			if (mo.state == S_PLAY_STND
			or mo.state == S_PLAY_JUMP
			or mo.state == S_PLAY_SPRING
			or mo.state == S_PLAY_EDGE)
			and p.realrobot.state ~= S_TAILS_ROBOT
				p.realrobot.state = S_TAILS_ROBOT
			end
			-- Robot Walking Frames
			if (mo.state == S_PLAY_FALL
			or mo.state == S_TAILS_CORK
			or mo.state == S_PLAY_WALK
			or P_PlayerInPain(p))
			and p.realrobot.state ~= S_TAILS_ROBOWALK
				p.realrobot.state = S_TAILS_ROBOWALK
			end
			-- Robot Flying Frames
			if (mo.state == S_PLAY_FLY
			or mo.state == S_PLAY_FLY_TIRED
			or mo.state == S_PLAY_SWIM)
			and p.realrobot.state ~= S_TAILS_ROBOFLY
				if p.realrobot.state == S_TAILS_ROBOFLY2
					return
				end
				p.realrobot.state = S_TAILS_ROBOFLY
			end
			-- Part 2
			if (mo.state == S_PLAY_FLY
			or mo.state == S_PLAY_FLY_TIRED
			or mo.state == S_PLAY_SWIM)
			and p.realrobot.state ~= S_TAILS_ROBOFLY2
				if p.realrobot.state == S_TAILS_ROBOFLY
					return
				end
				p.realrobot.state = S_TAILS_ROBOFLY2
			end
			if (p.cmd.buttons & BT_USE
			or p.exiting
			or mo.state == S_PLAY_DEAD
			or mo.state == S_PLAY_DRWN
			and not (mo.state == S_PLAY_FLY
			or mo.state == S_PLAY_FLY_TIRED
			or (mo.state == S_PLAY_SWIM and mo.eflags & MFE_UNDERWATER)))
			or not (mo.health or mo.valid)
			or mo.skin ~= "tatails"
				if p.powers[pw_carry] == CR_ZOOMTUBE
					return
				end
				P_SetOrigin(mo, p.robot.x, p.robot.y, p.robot.z)
				p.normalspeed = stats.normalspeed
				p.height = 48*FRACUNIT
				P_RemoveMobj(p.robot)
				P_RemoveMobj(p.realrobot)
				mo.state = S_PLAY_STND
				p.tailsroboting = false
			end
		end
		
		if not (player.cmd.buttons & BT_TOSSFLAG)
			player.tossready = true
			player.tosstapping = false
		elseif player.tossready
			player.tosstapping = true
			player.tossready = false
		else
			player.tosstapping = false
		end
		-----------------If you hit water, spawn a submarine!-------------------
		if (p.mo.eflags & MFE_UNDERWATER)
		and not ta_boss -- because there's no underwater bosses anywhere in this game. Not even modded I'm pretty sure
		and player.tosstapping
			if (p.robosub and p.robosub.valid)
				P_RemoveMobj(p.robosub)
				p.robosub = P_SpawnMobjFromMobj(p.mo, 0, 0, 0, MT_ROBOSUB)
				p.robosub.color = p.skincolor
				p.normalspeed = stats.normalspeed
				p.height = 48*FRACUNIT
				P_SetOrigin(mo, p.robot.x, p.robot.y, p.robot.z)
				P_RemoveMobj(p.realrobot)
				P_RemoveMobj(p.robot)
				p.tailsroboting = false
			else
				p.robosub = P_SpawnMobjFromMobj(p.mo, 0, 0, 0, MT_ROBOSUB)
				p.robosub.color = p.skincolor
				p.normalspeed = stats.normalspeed
				p.height = 48*FRACUNIT
				P_SetOrigin(mo, p.robot.x, p.robot.y, p.robot.z)
				P_RemoveMobj(p.realrobot)
				P_RemoveMobj(p.robot)
				p.tailsroboting = false
			end
		end
	end
	
	----------------------------------We all live in a blue submarine----------------------------------
	if player.tailssubbing
		if player.mo.state ~= S_TAILS_SUBBING
			player.mo.state = S_TAILS_SUBBING
		end
		--Why its not already doing this shit on its own when I turn "tailssubbing" to false i have no fucking idea PART 2!!!
		if (player.mo.state == S_PLAY_DEAD
		or player.mo.state == S_PLAY_RIDE
		or player.exiting
		or not (player.mo.health or player.mo.valid))
			player.mo.spritexscale = FU
			player.mo.spriteyscale = FU
			player.tailssubbing = false
		end
		if player.exiting
		and not P_IsObjectOnGround(player.mo)
			player.mo.state = S_TAILS_CORK
		end
		player.mo.spritexscale = FU*2/3
		player.mo.spriteyscale = FU*2/3
		player.powers[pw_underwater] = 999*TICRATE
		
		if not (player.mo.eflags & MFE_UNDERWATER)
			player.mo.momx = 0
			player.mo.momy = 0
			player.mo.momz = -10*FU
		else
			player.mo.momx = 0
			player.mo.momy = 0
			player.mo.momz = 0
		end
		
		if (player.mo.eflags & MFE_UNDERWATER)
			if (player.cmd.forwardmove > 25) -- up
				P_Thrust(player.mo, player.mo.angle, 20*FU)
			elseif (player.cmd.forwardmove < -25) -- down
				P_Thrust(player.mo, player.mo.angle, 20*FU)
			elseif (player.cmd.sidemove < -25) -- left
				P_Thrust(player.mo, player.mo.angle, 20*FU)
			elseif (player.cmd.sidemove > 25) -- right
				P_Thrust(player.mo, player.mo.angle, 20*FU)
			end
		end
		
		if (player.cmd.buttons & BT_JUMP)
		and (player.mo.eflags & MFE_UNDERWATER)
			P_SetObjectMomZ(player.mo, 8*FU)
		end
		if (player.cmd.buttons & BT_SPIN)
		and not P_IsObjectOnGround(player.mo)
			P_SetObjectMomZ(player.mo, -8*FU)
		end
	
		if (player.cmd.buttons & BT_CUSTOM1)
			p.robosub = P_SpawnMobjFromMobj(p.mo, 0, 0, 0, MT_ROBOSUB)
			P_TryMove(mo, 
			mo.x + P_ReturnThrustX(nil, mo.angle, 50*FRACUNIT),
			mo.y + P_ReturnThrustY(nil, mo.angle, 50*FRACUNIT), true)
			p.robosub.state = S_TAILS_ROBOTRANS2
			p.robosub.color = p.skincolor
			player.tailssubbing = false
			player.powers[pw_underwater] = 30*FU
			player.mo.spritexscale = FU
			player.mo.spriteyscale = FU
			player.mo.state = S_TAILS_CORK
			player.pflags = $|PF_THOKKED
		end
	end
	
	if player.tailssubbing == false
		player.mo.spritexscale = FU
		player.mo.spriteyscale = FU
	end
	
-----------------------------------Control The Raido--------------------------------------
	if player.raidosong == nil
		player.raidosong = 1
	end

	if player.tailsraido
	and player.inventory[player.tailsselect] == "RAIDO"
	and not player.tailssubbing
		if player.nexttapping
			if player.raidosong == #raidotracks
				return
			end
			player.raidosong = $ + 1
			S_StartSound(nil, sfx_menu1, player)
		end
		if player.prevtapping
			if player.raidosong == 1
				return
			end
			player.raidosong = $ - 1
			S_StartSound(nil, sfx_menu1, player)
		end
		if player.cmd.buttons & BT_ATTACK
			S_ChangeMusic(raidomusic[player.raidosong], true, player)
			player.tailsraidoing = true
		end
		if player.tailsraidoing
			if player.cmd.buttons & BT_TOSSFLAG
				P_RestoreMusic(player)
			end
		end
	end
	
---------------------------------Give TA The Spindash--------------------------------------
	if player.tailssonic
	and player.inventory[player.tailsselect] == "TASONC"
	and not player.tailssubbing
		player.charability2 = CA2_SPINDASH
	else
		player.charability2 = CA2_NONE
	end
	
---------------------------------Activate The Teleport--------------------------------------
	local state = player.mo.state
	if player.exiting
	or player.tapickup
	or player.tasleep
	or state == S_TPIPE
	or state == S_TAILSPIN
	or state == S_UPSIDE
	or player.powers[pw_carry]
		return
	end
	if player.teleporting == nil
		player.teleporting = 70
	end
	
	if player.tailsteleport
	and player.inventory[player.tailsselect] == "TELE"
	and not player.tailssubbing
		if (player.cmd.buttons & BT_ATTACK)
		and player.teleporting
			if not player.tailsteleanim
				player.mo.state = S_TAILS_TELEPORT
				player.tailsteleanim = true
			end
			player.teleporting = $1 - 1
			if player.teleporting == 40
				S_StartSound(nil, sfx_tatele, player)
			end
			if player.teleporting > 0
				player.mo.momx = 0
				player.mo.momy = 0
				player.mo.momz = 0
			elseif player.teleporting <= 0
				P_SetOrigin(player.mo, house.x, house.y, house.z)
				player.teleporting = 70
			end
		elseif player.teleporting ~= 70
			player.teleporting = 70
			player.tailsteleanim = false
			player.mo.state = S_PLAY_STND
		end
	end
	
	if player.tailsnight
	and player.inventory[player.tailsselect] == "NVIS"
		player.light1 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_NIGHTVISIONPRO)
		player.light2 = P_SpawnMobjFromMobj(player.mo, 300*FU, 0, 0, MT_NIGHTVISIONPRO)
		player.light3 = P_SpawnMobjFromMobj(player.mo, 0, 300*FU, 0, MT_NIGHTVISIONPRO)
		player.light4 = P_SpawnMobjFromMobj(player.mo, -300*FU, 0, 0, MT_NIGHTVISIONPRO)
		player.light5 = P_SpawnMobjFromMobj(player.mo, 0, -300*FU, 0, MT_NIGHTVISIONPRO)
	end
end)

addHook("MobjThinker", function(mo)
	if not mo.lighttimer -- Can't make it stay bright forever
		mo.lighttimer = 1
		mo.fuse = TICRATE
		if mo.fuse == 0 -- Just to be certain they are being removed. Don't wanna cause lag
			P_KillMobj(player.light1)
			P_KillMobj(player.light2)
			P_KillMobj(player.light3)
			P_KillMobj(player.light4)
			P_KillMobj(player.light5)
		end
	end
	if (mo.subsector and mo.subsector.valid and mo.subsector.sector and mo.subsector.sector.valid) -- Do the sectors exist?
		if mo.subsector.sector.lightlevel < 183 -- Are they dimmer than light level 180?
			P_SpawnLightningFlash(mo.subsector.sector) -- Castle Eggman moment (Lightning lights up the world)
			mo.subsector.sector.lightlevel = 183 -- No they aren't
		end
		for fof in mo.subsector.sector.ffloors() --HEY! Light up the area where we are too if we're below something
			if fof.valid and (fof.flags & FF_EXISTS)
			and (fof.bottomheight >= mo.z
			or (mo.z < fof.topheight
			and mo.z+mo.height > fof.bottomheight))
			and fof.sector.valid and fof.sector.lightlevel < 183
				P_SpawnLightningFlash(fof.sector)
				fof.sector.lightlevel = 183
			end
		end
	end
end, MT_NIGHTVISIONPRO)